<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPhrase ArrayType
 * @subpackage Arrays
 */
class ArrayOfPhrase extends AbstractStructArrayBase
{
    /**
     * The Phrase
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\Phrase[]
     */
    public $Phrase;
    /**
     * Constructor method for ArrayOfPhrase
     * @uses ArrayOfPhrase::setPhrase()
     * @param \CustomerManagement\StructType\Phrase[] $phrase
     */
    public function __construct(array $phrase = array())
    {
        $this
            ->setPhrase($phrase);
    }
    /**
     * Get Phrase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\Phrase[]|null
     */
    public function getPhrase()
    {
        return isset($this->Phrase) ? $this->Phrase : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPhrase method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhrase method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhraseForArrayConstraintsFromSetPhrase(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPhrasePhraseItem) {
            // validation for constraint: itemType
            if (!$arrayOfPhrasePhraseItem instanceof \CustomerManagement\StructType\Phrase) {
                $invalidValues[] = is_object($arrayOfPhrasePhraseItem) ? get_class($arrayOfPhrasePhraseItem) : sprintf('%s(%s)', gettype($arrayOfPhrasePhraseItem), var_export($arrayOfPhrasePhraseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Phrase property can only contain items of type \CustomerManagement\StructType\Phrase, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Phrase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\Phrase[] $phrase
     * @return \CustomerManagement\ArrayType\ArrayOfPhrase
     */
    public function setPhrase(array $phrase = array())
    {
        // validation for constraint: array
        if ('' !== ($phraseArrayErrorMessage = self::validatePhraseForArrayConstraintsFromSetPhrase($phrase))) {
            throw new \InvalidArgumentException($phraseArrayErrorMessage, __LINE__);
        }
        if (is_null($phrase) || (is_array($phrase) && empty($phrase))) {
            unset($this->Phrase);
        } else {
            $this->Phrase = $phrase;
        }
        return $this;
    }
    /**
     * Add item to Phrase value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\Phrase $item
     * @return \CustomerManagement\ArrayType\ArrayOfPhrase
     */
    public function addToPhrase(\CustomerManagement\StructType\Phrase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\Phrase) {
            throw new \InvalidArgumentException(sprintf('The Phrase property can only contain items of type \CustomerManagement\StructType\Phrase, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Phrase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\Phrase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\Phrase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\Phrase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\Phrase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\Phrase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Phrase
     */
    public function getAttributeName()
    {
        return 'Phrase';
    }
}
